﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Infragistics.Win;
using Infragistics.Win.UltraWinGanttView.UIElements;
using System.Data;
using System.Drawing;

namespace GanttSample
{
    public class DrawFilter : IUIElementDrawFilter
    {
        //private Dictionary<TaskExecutionState, Image> _taskStateImageCache;


        #region IUIElementDrawFilter method implementations
        public DrawPhase GetPhasesToFilter(ref UIElementDrawParams drawParams)
        {
            UIElement elem = drawParams.Element;

            if (elem is ImageUIElement)
                return DrawPhase.BeforeDrawImage;

            return DrawPhase.None;
        }


        public bool DrawElement(DrawPhase drawPhase, ref UIElementDrawParams drawParams)
        {
            switch (drawPhase)
            {
                case DrawPhase.BeforeDrawImage:
                    DrawPhase_BeforeDrawImage(ref drawParams);
                    break;

                case DrawPhase.BeforeDrawElement:
                    DrawPhase_BeforeDrawElement(ref drawParams);
                    break;

                default:
                    break;
            }

            return false;
        }
        #endregion


        #region Private methods
        private void DrawPhase_BeforeDrawImage(ref UIElementDrawParams drawParams)
        {
            UIElement elem = drawParams.Element;
            UIElement prnt = drawParams.Element.Parent;

            ImageUIElement imgElem = elem as ImageUIElement;
            TaskBarUIElement taskElem = prnt as TaskBarUIElement;
            if (imgElem != null && taskElem != null)
            {
                Infragistics.Win.UltraWinSchedule.Task task =
                    taskElem.GetContext() as Infragistics.Win.UltraWinSchedule.Task;

                if (task != null)
                    imgElem.Image = GetImageForTaskState(task);
            }
        }


        private void DrawPhase_BeforeDrawElement(ref UIElementDrawParams drawParams)
        {

        }
        #endregion


        private Image GetImageForTaskState(Infragistics.Win.UltraWinSchedule.Task task)
        {
            Guid taskId = Guid.Empty;

            if (task == null)
                return null;

            //if (_taskStateImageCache == null)
            //    _taskStateImageCache = CreateTaskImageCache();

            //DataRowView drView = task.BindingListObject as DataRowView;
            //TaskExecutionState taskState = (TaskExecutionState)drView.Row["TaskExecutionState"];

            //return _taskStateImageCache[taskState];
            return null;
        }


        //private Dictionary<TaskExecutionState, Image> CreateTaskImageCache()
        //{
        //    Dictionary<TaskExecutionState, Image> imgCache = new Dictionary<TaskExecutionState, Image>();

        //    imgCache.Add(TaskExecutionState.Proposed, (Image)Properties.Resources.sphere_16_DIS.Clone());
        //    imgCache.Add(TaskExecutionState.Scheduled, (Image)Properties.Resources.clock_16.Clone());
        //    imgCache.Add(TaskExecutionState.InProcess, (Image)Properties.Resources.play_16.Clone());
        //    imgCache.Add(TaskExecutionState.Performed, (Image)Properties.Resources.ok_16.Clone());
        //    imgCache.Add(TaskExecutionState.Cancelled, (Image)Properties.Resources.cancel_16.Clone());

        //    return imgCache;
        //}
    }
}
